# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para mocosoftx
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import cookielib
import urlparse,urllib2,urllib,re
import os
import sys

try:
    from core import logger
    from core import config
    from core import scrapertools
    from core.item import Item
    from servers import servertools
except:
    # En Plex Media server lo anterior no funciona...
    from Code.core import logger
    from Code.core import config
    from Code.core import scrapertools
    from Code.core.item import Item
    
import xbmc

PARSEPOST = False
CHANNELNAME = "mocosoftx"
USER = config.get_setting("privateuser")
PASSWORD = config.get_setting("privatepassword")
BASEURL = "http://www.mocosoftx.foro/"

#La cookie se ha de ubicar en un sitio con permiso de lectura/escritura
COOKIEFILE = os.path.join(config.get_data_path(),"mocosoftx.cookies")
####################################################
# COKIES
####################################################
# Cookie jar. Stored at the user's home folder.
try:
    cookie_jar = cookielib.LWPCookieJar(COOKIEFILE)
    cookie_jar.load()
except:
    pass

DEBUG=True

def isGeneric():
    return True

def mainlist(item):
    logger.info("[mocosoftx.py] mainlist")
    itemlist = []
    # Añade al listado de XBMC
    #xbmctools.addnewfolder( CHANNELNAME , "Novedades" , category , "Novedades"            ,"http://mocosoftx.com/foro/index.php"+sid,"","")
    itemlist.append( Item( channel=CHANNELNAME , title="Novedades" , action="Novedades" , url="http://mocosoftx.com/foro/index.php", folder=True ) )
    itemlist.append( Item( channel=CHANNELNAME , title="Escenas HD" , action="Forum" , url="http://mocosoftx.com/foro/escenas-hd-online/", folder=True ) )
    itemlist.append( Item( channel=CHANNELNAME , title="Películas XXX" , action="Forum" , url="http://mocosoftx.com/foro/peliculas-xxx-online-(completas)/", folder=True ) )
    itemlist.append( Item( channel=CHANNELNAME , title="Escenas XXX" , action="Forum" , url="http://mocosoftx.com/foro/escenas-xxx-online/", folder=True ) )
    itemlist.append( Item( channel=CHANNELNAME , title="Películas eróticas" , action="Forum" , url="http://mocosoftx.com/foro/peliculas-eroticas-online-(completas)/", folder=True ) )
    itemlist.append( Item( channel=CHANNELNAME , title="Películas y capítulos Hentai" , action="Forum" , url="http://mocosoftx.com/foro/peliculas-y-capitulos-hentay-online-(completas)/", folder=True ) )
    itemlist.append( Item( channel=CHANNELNAME , title="Buscador..." , action="search" , url="http://mocosoftx.com/foro/search2/", folder=True ) )
    
    return itemlist

def Novedades(item):
        logger.info("[mocosoftx.py] Novedades")

        itemlist = []
        scrapedplot = ""
        # Descarga la página
        data = get_page(item.url)
       
        #Parseamos los post 
        posts =re.compile('<table class="sp_block">.*?</table>', re.S).findall(data)
        if (len(posts)>0):
            for post in posts:
                data2 = post
                scrapedurl = ""
                scrapedtitle = ""                   
                secciones  = re.compile('<td class="sp_middle sp_regular_padding sp_fullwidth">.*?</td>', re.S).findall(data2)
                if (len(secciones)>0):
                    for info in secciones:
                        patron = 'href="([^"]+)">([^<]+)</a>'
                        matches = re.compile(patron,re.DOTALL).findall(info)
                        for match in matches:
                            scrapedurl = match[0]
                            scrapedtitle = match[1]
                            break
                        break
                   
                if (scrapedurl!=""):
                    scrapedthumbnail = ""
                    secciones  = re.compile('<div class="post">.*?</table>', re.S).findall(data2)
                    if (len(secciones)>0):
                        for info in secciones:
                            patron = '<img src="([^"]+)"'
                            matches = re.compile(patron,re.DOTALL).findall(info)
                            for match in matches:
                                scrapedthumbnail = match
                                break
                            break
                    itemlist.append( Item( channel=CHANNELNAME , title=scrapedtitle , action="detail" , url=scrapedurl , plot=scrapedplot, thumbnail=scrapedthumbnail, folder=True ) )
                       

        # Extrae la marca de siguiente página
        patronvideos = '\[<b>[^<]+</b>\] <a class="navPages" href="([^"]+)">'
        matches = re.compile(patronvideos,re.DOTALL).findall(data)
        scrapertools.printMatches(matches)
    
        if len(matches)>0:
            scrapedtitle = "Página siguiente"
            scrapedurl = urlparse.urljoin(item.url,matches[0])
            scrapedthumbnail = ""
            scrapedplot = ""
            itemlist.append( Item( channel=CHANNELNAME , title=scrapedtitle , action="Novedades" , url=scrapedurl , plot=scrapedplot, thumbnail=scrapedthumbnail, folder=True ) )

        return itemlist
    

def search(item):
    logger.info("[Vagos.py] search")
    itemlist = []
    
    keyboard = xbmc.Keyboard('')
    keyboard.doModal()
    itemlist.append( Item( channel=CHANNELNAME , title="Buscador..." , action="search" , url="http://mocosoftx.com/foro/search2/", folder=True ) )
          
    if (keyboard.isConfirmed()):
        tecleado = keyboard.getText()
        if len(tecleado)>0:
            #convert to HTML
            tecleado = tecleado.replace(" ", "+")
           
            itemlist = ShowSearchResult(tecleado, item, itemlist)
               
    return itemlist
     
     

def ShowSearchResult(tecleado, item, itemlist):
    data = Search(tecleado)
    numresult = 0
    scrapedplot=""   
    #Parseamos los post 
    posts =re.compile('<table width="100%" cellpadding="4" cellspacing="1" border="0" class="bordercolor">.*?</table>', re.S).findall(data)
    if (len(posts)>0):
        for post in posts:
            data2 = post 
            scrapedurl = ""
            scrapedtitle = ""                   
            secciones  = re.compile('<div style="float: left;">.*?</div>', re.S).findall(data2)
            if (len(secciones)>0):
                linknum=0
                for info in secciones:
                    patron = '<a href="([^"]+)">(.*?)</a>'
                    matches = re.compile(patron,re.DOTALL).findall(info)
                    for match in matches:
                        linknum=linknum+1
                        if(linknum==3):
                            numresult= numresult+1
                            scrapedurl = match[0]
                            scrapedtitle = str(numresult) + ".- " + match[1]
                            scrapedtitle = scrapedtitle.replace('<b class="highlight">',"")
                            scrapedtitle = scrapedtitle.replace('</b>',"")
                            break
                    break
                   
            if (scrapedurl!=""):
                scrapedthumbnail = ""
                secciones  = re.compile('<div class="post">.*?</table>', re.S).findall(data2)
                if (len(secciones)>0):
                    for info in secciones:
                        patron = '<img src="([^"]+)"'
                        matches = re.compile(patron,re.DOTALL).findall(info)
                        for match in matches:
                            scrapedthumbnail = match
                            break
                        break
                itemlist.append( Item( channel=CHANNELNAME , title=scrapedtitle , action="detail" , url=scrapedurl , plot=scrapedplot, thumbnail=scrapedthumbnail, folder=True ) )
                       

        # Extrae la marca de siguiente página
        patronvideos = '\[<b>[^<]+</b>\] <a class="navPages" href="([^"]+)">'
        matches = re.compile(patronvideos,re.DOTALL).findall(data)
        scrapertools.printMatches(matches)
    
        if len(matches)>0:
            scrapedtitle = "Página siguiente"
            scrapedurl = urlparse.urljoin(item.url,matches[0])
            scrapedthumbnail = ""
            scrapedplot = ""
            itemlist.append( Item( channel=CHANNELNAME , title=scrapedtitle , action="search" , url=scrapedurl , plot=scrapedplot, thumbnail=scrapedthumbnail, folder=True ) )

        return itemlist
    
def Forum(item):
        logger.info("[mocosoftx.py] Novedades")
        itemlist = []
    
        # Descarga la página
        data = get_page(item.url)
        
        #Parseamos los post 
        posts =re.compile('<span id="msg_.*?</span>', re.DOTALL).findall(data)
        if (len(posts)>0):
            for post in posts:
               
                link = ""
                title = ""                   
                patron = 'href="([^"]+)">([^<]+)</a>'
                matches = re.compile(patron,re.DOTALL).findall(post)
                for match in matches:
                    link = match[0]
                    title = match[1]
                    break
                   
                if (link!=""):
                    if (PARSEPOST):
                        itemlist=ValidateAndAddVideo(title,link, itemlist)
                    else:
                        itemlist.append( Item( channel=CHANNELNAME , title=title , action="detail" , url=link , plot="", thumbnail="", folder=True ) )

                    
                     
       
        # Extrae la marca de siguiente página
        patronvideos = '\[<b>[^<]+</b>\] <a class="navPages" href="([^"]+)">'
        matches = re.compile(patronvideos,re.DOTALL).findall(data)
        scrapertools.printMatches(matches)
    
        if len(matches)>0:
            scrapedtitle = "Página siguiente"
            scrapedurl = urlparse.urljoin(item.url,matches[0])
            scrapedthumbnail = ""
            scrapedplot = ""
            itemlist.append( Item( channel=CHANNELNAME , title=scrapedtitle , action="Forum" , url=scrapedurl , plot=scrapedplot, thumbnail=scrapedthumbnail, folder=True ) )

        return itemlist
       
#Como no deja de ser un foro, parseamos los post para ver si tienen contenido para reproducir
#De paso intentamos obtener un thumbnail       
def ValidateAndAddVideo(scrapedtitle,link, itemlist):
    data = get_page(link)
    scrapedplot = ""
    patronthumb = '<img src="([^"]+)" alt="" border="0" />[</a>|<br />]+'
    matches = re.compile(patronthumb,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)
    try:
        scrapedthumbnail = matches[1]
    except:
        scrapedthumbnail = ""
    listavideos = servertools.findvideos(data)
    if (len(listavideos)>0):
        itemlist.append( Item( channel=CHANNELNAME , title=scrapedtitle , action="detail" , url=link , plot=scrapedplot, thumbnail=scrapedthumbnail, folder=True ) )

    return itemlist

def detail(item):
    logger.info("[mocosoftx.py] detail")
    itemlist = []
    url = item.url
    title = urllib.unquote_plus( item.title )
    thumbnail = urllib.unquote_plus( item.thumbnail )
    #plot = unicode( xbmc.getInfoLabel( "ListItem.Plot" ), "utf-8" )
    if "CDATA" in url:
        data = url
        patronthumb = '<img src="([^"]+)"'
        matches = re.compile(patronthumb,re.DOTALL).findall(data)
        scrapertools.printMatches(matches)
    else:
        #Descarga la página
        data = get_page(url)
        patronthumb = '<img src="([^"]+)" alt="" border="0" />[</a>|<br />]+'
        matches = re.compile(patronthumb,re.DOTALL).findall(data)
        scrapertools.printMatches(matches)
    #logger.info(data)
    #addnewvideo( canal , accion , category , server , title , url , thumbnail, plot ):
    # ------------------------------------------------------------------------------------
    # Busca los enlaces a los videos
    # ------------------------------------------------------------------------------------
    listavideos = servertools.findvideos(data)
    c=0
    for video in listavideos:
        c=c+1
        try:
            imagen = matches[c]
        except:
            imagen = thumbnail
        itemlist.append( Item(channel=CHANNELNAME, action="play" , title=title+" - ["+video[2]+"]", url=video[1], thumbnail=imagen, plot="", server=video[2], folder=False))
    
    # ------------------------------------------------------------------------------------
    
    return itemlist

# Request the given URL and return the response page, using the cookie jar
def get_page(url):   
    request = urllib2.Request(url)
    request.add_header('User-Agent', 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0)')
    cookie_jar.add_cookie_header(request)
    response = urllib2.urlopen(request)
    html = response.read()
    response.close()
   
    return html

def Search(text):
   
    url = 'http://mocosoftx.com/foro/search2/'
    values = {'advanced' : '1',
          'search' : text,
          'searchtype' : '2',
          'userspec' : '*',
          'show_complete' : '1',
          'subject_only' : '1',
          'minage' : '0',
          'maxage' : '9999',
          'sort' : 'relevance|desc',
          'brd[30]' : '30',
          'brd[14]' : '14',
          'brd[15]' : '15',
          'brd[17]' : '17',
          'brd[18]' : '18'}

    search_data = urllib.urlencode(values)
    request = urllib2.Request(url,search_data)
    request.add_header('User-Agent', 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0)')
    cookie_jar.add_cookie_header(request)
    response = urllib2.urlopen(request)
    html = response.read()
    response.close()
   
    return html

# Request the given URL and return the response page, using the cookie jar
def Login():
    url = 'http://mocosoftx.com/foro/login2/'
    values = {'user' : USER,
          'cookielength' : '-1',
          'passwrd' : PASSWORD,
          'cookieneverexp' : 'on',
          'hash_passwrd' : ''}
    login_data = urllib.urlencode(values)

    opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cookie_jar))
    urllib2.install_opener(opener)
       
    request = urllib2.Request(url,login_data)
    request.add_header('User-Agent', 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0)')
    response = urllib2.urlopen(request)
    html = response.read()
    response.close()
    cookie_jar.save()
    return html
